

function RuleFilterCtrl($scope, $http, $rootScope){
  $http.get('json/nvkl.min.json').success(function (response) {
    $scope.refrigerants = response.data.koudemiddelen.middelen;
    $scope.refrigerantTypes = response.data.koudemiddelen.types;
    $scope.fitments = response.data.type_inrichtingen;
    $scope.pedCategories = response.data.PED;
    $scope.fitmentTypes = response.data.type_inrichtingen;

    $scope.pedRefrigerantRules = response.rules.ped_koudemiddelen;
    $scope.gasRegulationRules = response.rules.gassenverordening;
    $scope.naturalRefrigerantRules = response.rules.nk_activiteitenbesluit;
    $scope.personCoolingRules = response.rules.epbd_personenkoeling;

    //$scope.activeFilters = [];

    /* Form defaults */ /*
    $scope.refrigerantAmount = 1;
    $scope.refrigerantType = 2;
    $scope.fitmentType = 0;
    $scope.coolingPower = 1;
    $scope.pedCategory = 3;
    //*/

    /*
    var json = [
      $scope.gasRegulationRules,
      $scope.naturalRefrigerantRules,
      $scope.personCoolingRules,
      $scope.pedRefrigerantRules
    ];

    addDescr(['id', 'inhoud'], $scope.gasRegulationRules, 'gassenverordening');
    addDescr(['id', 'inhoud'], $scope.naturalRefrigerantRules, 'nk');
    addDescr(['id', 'koelvermogen'], $scope.personCoolingRules, 'epbd');
    addDescr(['id', 'categorie'], $scope.pedRefrigerantRules, 'ped');

    for(var key in json){
      console.log(JSON.stringify(json[key]));
    } */
  });

  function addDescr(exclude, src, type){

    for(var i in src){
      var advice = src[i];

      for(var key in advice){
        if(! inArray(key, exclude)) {
          var descr = 'Geen beschrijving';

          if (type == 'gassenverordening') {
            switch(key){
              case 'controle':
                descr = 'Verordening (EG) nr.842/2006 <br />art. 3 lid 2';
                break;
              case 'logboek':
                descr = 'Verordening (EG) nr.842/2006 <br />art 3 lid 6';
                break;
              case 'kenplaat/etiket':
                descr = 'Verordening (EG) nr.842/2006 <br />art. 7';
                break;
              case 'automatische_lekdetectie':
                descr = 'Verordening (EG) nr.842/206 <br />Art 3 lid 3';
                break;
              case 'gebruikershandleiding':
                descr = 'Machinerichtlijn 2006/42/EG <br />Art. 5 lid 1c';
                break;
              case 'gecertificeerd_bedrijf':
                descr = 'Verordening (EG) nr.842/2006 <br />Art.5 + Ministeriële regeling art.18';
                break;
              case 'gediplomeerd_monteur':
                descr = 'Verordening (EG) nr.842/2006 <br />Art.5 + Ministeriële regeling art.18';
                break;
              case 'logboek_kaart':
                descr = 'Interpretatie document I&M <br />versie 1 augustus 2011';
                break;
            }
          }
          else if(type == 'nk') {
            switch(key){
              case 'controle':
              case 'logboek':
              case 'kenplaat/etiket':
              case 'automatische_lekdetectie':
              case 'gebruikershandleiding':
              case 'gecertificeerd_bedrijf':
              case 'gediplomeerd_monteur':
                descr = 'Wetsartikelen volgen bij publicatie van deze regeling rond dec 2012';
                break;
            }
          }
          else if(type == 'epbd'){
            switch (key) {
              case 'koelvermogen':
              case 'aantal_inspecties':
              case 'logboek':
              case 'gecertificeerd_inspecteur':
                 descr = 'Wetsartikelen volgen bij publicatie van deze regeling rond dec 2012';
                 break;
            }
          }
          else if(type == 'ped'){
            switch (key) {
              case 'inspectie':
                descr = 'Warenwet regeling drukapparatuur <br /> Artikel 6';
                break;
              case 'logboek':
                descr = 'Richtlijn 97/23/EG <br /> Bijlage I onder 3.4';
                break;
              case 'kenplaat/etiket':
                descr = 'Richtlijn 97/23/EG <br /> Bijlage I onder 3.3';
                break;
              case 'ce_verklaring':
                descr = 'Richtlijn 97/23/EG <br /> Artikel 5 en 15';
                break;
              case 'gebruikershandleiding':
                descr = 'Richtlijn 97/23/EG <br /> Bijlage I onder 3.4';
                break;
              case 'aangewezen_keuringsinstantie':
                descr = 'Waren regeling drukapparatuut <br /> Artikel 15';
                break;
              case 'gecertificeerd_inspecteur':
                 descr = 'Waren regeling drukapparatuut <br/> Artikel 15';
                 break;
            }
          }

          // modify src value
          advice[key].descr = descr;
        }
      }
    }
  }

  //*/

  $rootScope.log = function(variable) {
    console.log(variable);
  };

  $scope.gasRegulation = function(amount, type){
    if(amount == null || type == undefined) return;

    var adviceID = null,
    advice,
    refrigerantType = $scope.refrigerantTypes[type];

    var condition = $scope.match(refrigerantType.type, ['HFK', 'HCFK', 'HFO']);
    if(condition) {
      if ((amount < 3)) {
        adviceID = 0;
      }
      else if(amount >= 3 && amount < 30) {
        adviceID = 1;
      }
      else if(amount >= 30 && amount < 300) {
        adviceID = 2;
      }
      else if(amount >= 300){
        adviceID = 3;
      }

      // get the advice/rule
      advice = getGasRegulationAdvice(adviceID);
      return advice;
    }
  };

  $scope.naturalRefrigerants = function(amount, type){
    if(amount == undefined || type == undefined) return;

    var adviceID = null,
    advice,
    refrigerantType = $scope.refrigerantTypes[type];

    if (refrigerantType.type == 'NK') {
      if (amount < 12) {
        adviceID = 0;
      }
      else if (amount >= 12 && amount < 1500) {
        adviceID = 1;
      }

      if (adviceID != null) {
        // get the advice
        advice = getNaturalRefrigerantAdvice(adviceID);
        return advice;
      }
    }
    return false;

  };

  $scope.personCooling = function(kw, fitmentID){
    if(kw == undefined || fitmentID == undefined) return;

    var fitment = $scope.fitmentTypes[fitmentID], adviceID;

    if (fitment.type == 'Gebouw') {
      if(kw <= 12){
        adviceID = 0;
      }
      else if(kw > 12 && kw <= 45){
        adviceID = 1;
      }
      else if(kw > 45 && kw <= 270){
        adviceID = 2;
      }
      else if(kw > 270){
        adviceID = 3;
      }

      if (adviceID != null) {
        // get the advice
        return getPersonCoolingAdvice(adviceID);
      }
    }
    return false;
  };

  $scope.pedRefrigerants = function(pedCategoryID){
    if (pedCategoryID == undefined) return;
    var pedCategory = $scope.pedCategories[pedCategoryID];

    for(var index in $scope.pedRefrigerantRules){
      var advice = $scope.pedRefrigerantRules[index];

      if (advice.categorie == pedCategory.id){
        return advice;
      }
    }
    return false;
  };

  var getPersonCoolingAdvice = function(adviceID){
    return getAdvice(adviceID, $scope.personCoolingRules);
  };

  var getNaturalRefrigerantAdvice = function(adviceID){
    return getAdvice(adviceID, $scope.naturalRefrigerantRules);
  };

  var getGasRegulationAdvice = function(adviceID){
    return getAdvice(adviceID, $scope.gasRegulationRules);
  };

  var getAdvice = function(adviceID, src){
    for(var i in src) {
      var advice = src[i];
      if(advice.id == adviceID) return advice;
    }
    // When adviceID isn't found,
    return false;
  };

  $scope.enableButton = function(bools, replacement){
    for(var key in bools){
      if (bools[key]) { 

        if (replacement != undefined) {
          return replacement;
        }
        return true;
      }
    }
    return (replacement != undefined) ? '#' : false;
  };

  // utilities
  $scope.toggle = function(bool){
    return (bool) ? false : true;
  };

  $scope.display = function(args){
    var error = false;
    error = inArray(undefined, args);
    return !error;
  };

  $scope.match = function(value, matches){
    return inArray(value, matches);
  };

  // this function doesn't modify the value, like the checkmark filter does
  // and thereby does not interfere with the content that is displayed to
  // the user
  $scope.checkmark = function(input, key){
    var intval = parseInt(input, 10);

    var setCheckmark = function(value){
      var checkmark = {};
      checkmark.yes = 'true';
      checkmark.no = 'false';

      if(value == 1 && key != 'categorie'){
        return checkmark.yes;
      }
      else if(value == 0 && key != 'categorie'){
        return checkmark.no;
      }
      else if(typeof value == 'string'){
        //console.log(value);
      }
      else {
        return 'default';
      }
    };

    if(intval == input) {
      return setCheckmark(intval);
    }

    if (isArray(input)) {
      for(var key in input){
        if(input[key] == '<span class="checkmark-yes">ja</span>') { return setCheckmark(1); }
        if(input[key] == '<span class="checkmark-no">nee</span>') { return setCheckmark(0); }
      }
    }
    if(angular.isString(input)){
      return setCheckmark(1);
    }
    return 'default';
  };

  function inArray(needle, haystack) {
    var length = haystack.length;
    for(var i = 0; i < length; i++) {
      if(haystack[i] == needle) return true;
    }
    return false;
  }

  // test
  $scope.myOrder = function(a){
    return 2;
  };

}
