"use strict";

angular.module('nvklFilters', [])
    .filter('label', function(){
        return function(input) {
            var value;

            if(!isString(input)) { return input; }

            if(input == 'ce_verklaring') {
                return 'CE-verklaring';
            }
            value = input.replace('_', ' ');
            return value;
        };
    })
    .filter('ucfirst', function(){
        return function(input) {
            input += '';
            var f = input.charAt(0).toUpperCase();
            return f + input.substr(1);
        };
    })
    .filter('joinarray', function(){
        return function(input) {
            if(isArray(input)){
                input = input.join(', ');
            }
            return input;
        };
    })
    .filter('category', function(){
        return function(input, key, category) {
            if(key == 'categorie'){
                return category.value;
            }
            return input;
        };
    })
    .filter('checkmark', function(){
        return function(input, bool) {
            var value = parseInt(input, 10);

            var setCheckmark = function(value, bool){
                var checkmark = {};

                checkmark.yes = '<span class="checkmark-yes">ja</span>';
                checkmark.no = '<span class="checkmark-no">nee</span>';

                if(bool == 'class'){
                    checkmark.yes = 'true';
                    checkmark.no = 'false';
                }

                if(value == 1){
                    return checkmark.yes;
                }
                else if(value == 0){
                    return checkmark.no;
                }
            };

            if(value == input) {
                return setCheckmark(value, bool);
            }
            else if(isArray(input)){
                for(var key in input){
                    var val = input[key], intVal;

                    if(parseInt(val, 10) == val){
                       var checkmark = setCheckmark(val, bool);
                       input[key] = checkmark;
                    }
                }
            }
            return input;
        };
    })
;

// TODO: create utility module, ex. is.array()?
function isArray(input){
    return (typeof(input)=='object' && (input instanceof Array)) ? true : false;
}
function isString(input){
    return (typeof(input)=='string') ? true : false;
}
