var jqt = $.jQTouch({
    icon: 'logo-installatiecheck.png',
    addGLossToIcon: false,
    startupScreen: 'static/img/jqt_startup.png',
    statusBar: 'black'
});

var flux = (function($){
  var priv = {};
  var pub = {};

  priv.pages = [
    {id: 1, slug: 'installatiecheck', title: '<span>Ga naar de</span><br> Koel en klimaat Installatiecheck'},
    {id: 2, slug: 'nvkl', title: 'NVKL'},
    {id: 3, slug: 'infomil', title: 'InfoMil'},
    {id: 4, slug: 'wetgeving', title: 'Wetgeving koel- en klimaattechniek'},
    {id: 5, slug: 'certificeringen', title: 'Verplichte certificeringen'},
    {id: 6, slug: 'koudemiddelen', title: 'Koudemiddelen'},
    {id: 7, slug: 'about', title: 'Over de Installatiecheck app'}
  ];

  pub.hideAddressBar = function()  {
    if(!window.location.hash)
    {
      if(document.height < window.outerHeight)
      {
        document.body.style.height = (window.outerHeight + 50) + 'px';
      }

      setTimeout( function(){ window.scrollTo(0, 1); }, 50 );
    }
    window.addEventListener("load", function(){ if(!window.pageYOffset){ hideAddressBar(); } } );
    window.addEventListener("orientationchange", hideAddressBar );
  };

  pub.makeScrollable = function(){
    $(document).on('pageAnimationEnd', function(){
      var current = $('.current');
      var height = {
        doc: $(document).height(),
        content: $('.content', current).height(),
        body: $('body').height(),
        jqt: $('#jqt').height()
      };
    });
  };

  pub.renderPartials = function(enable){
    if(!enable) { return; }

    var pages = priv.pages;
    for(var i in pages){
      var page = pages[i];
      var menuitem = '<li class="menu-{0}"><a class="slide" href="#{0}">{1}</a></li>'
        .format(page.slug, page.title);

      $('.main-menu ul').append(menuitem);

      if (page.slug != 'installatiecheck') {
        var html = $('#'+page.slug);
        var title = '<h2 class="secondary-title">{0}</h2>'.format(html.find('.toolbar h1').text());
        html.find('.toolbar').after(title);
        html.find('.toolbar h1').text($('#installatiecheck .toolbar h1').text());
      }

      $.ajax({
        type: 'GET',
        url: 'static/partials/'+page.slug+'.html',
        //data: {slug: page.slug},
        dataType: 'html',
        success: function(response, e){
          if (page.slug != 'installatiecheck') {
          $('body').trigger('appended', response);
        }
        }
      });
    }

    priv.onPartialAppend();
  };

  priv.onPartialAppend = function(){
    $('body').on('appended', function(e, data){
      var html = $(data);
      $(this).append(html);
      var title = '<h2 class="secondary-title">{0}</h2>'.format(html.find('.toolbar h1').text());
      html.find('.toolbar').after(title);
      html.find('.toolbar h1').text($('#installatiecheck .toolbar h1').text());
    });
  };

  pub.fixedToolbar = function(enable){
    if (!enable) { return; }

    $('body').on('pageAnimationEnd', function(e, data){
      var current = $('.current'),
      mainToolbar = $('#main-toolbar');

      var is_fullscreen = current.hasClass('fullscreen');

      if(is_fullscreen){
        mainToolbar.trigger('hideToolbar');
        return;
      }

      mainToolbar.removeClass('hide-toolbar').addClass('show-toolbar');
      $('.toolbar',current).css('visibility', 'hidden');
      mainToolbar.html(current.find('.toolbar').html());
    });

    $('#main-toolbar').on('hideToolbar', function(e){
      $(this).removeClass('show-toolbar').addClass('hide-toolbar');
    });
  };

  pub.enableButton = function(){

  };

  return pub;
}($));

var pages = [
    {id: 1, slug: 'installatiecheck', title: 'Koel en klimaat Installatiecheck'},
    {id: 2, slug: 'nvkl', title: 'NVKL'},
    {id: 3, slug: 'infomil', title: 'InfoMil'},
    {id: 4, slug: 'wetgeving', title: 'Wetgeving koel- en klimaattechniek'},
    {id: 5, slug: 'certificeringen', title: 'Verplichte certificeringen'},
    {id: 6, slug: 'koudemiddelen', title: 'Koudemiddelen'},
    {id: 7, slug: 'about', title: 'Over de Installatiecheck app'}
];

// TODO: move to controller
var links = [{"text":"Arbowetgeving","url":"http://www.nvkl.nl/Ledendiensten/arbowetgeving.aspx"},{"text":"EPBD","url":"http://www.nvkl.nl/Ledendiensten/epbd.aspx"},{"text":"EUP","url":"http://www.nvkl.nl/Ledendiensten/eup.aspx"},{"text":"F-gassenverordening","url":"http://www.nvkl.nl/Ledendiensten/f-gassenverordening.aspx"},{"text":"Machinerichtlijn","url":"http://www.nvkl.nl/Ledendiensten/machinerichtlijn.aspx"},{"text":"Ozonverordening (HCFK's)","url":"http://www.nvkl.nl/Ledendiensten/ozonverordening.aspx"},{"text":"Activiteitenbesluit","url":"http://www.nvkl.nl/Ledendiensten/activiteitenbesluit.aspx"},{"text":"RES","url":"http://www.nvkl.nl/Ledendiensten/res.aspx"},{"text":"Richtlijn Drukapparatuur (PED)","url":"http://www.nvkl.nl/Ledendiensten/richtlijndrukapparatuur-ped.aspx"},{"text":"Verwijderingsbijdrage (WEEE)","url":"http://www.nvkl.nl/Ledendiensten/verwijderingsbijdrage.aspx"},{"text":"Vervoer koudemiddelen en gassen","url":"http://www.nvkl.nl/Ledendiensten/vervoerkoudemiddelenengassen.aspx"}];

$(document).ready(function(){

  flux.renderPartials(true);
    var mia = $('.menu-installatiecheck a'); mia.html('<span class="text">'+mia.html()+'</span><span class="pointer right">&raquo;</span>');
  flux.fixedToolbar(false);

  //flux.makeScrollable();

  if (navigator.userAgent.indexOf('Android') != -1) {
    $('body').addClass('os-android');
  }

  if (navigator.userAgent.indexOf('Firefox') != -1) {
    $('body').addClass('firefox');
  }

  var initHeight = $('body').height();

  $('body').on('pageAnimationStart', function(e, data){
    //$(this).height($('div.current').height());
    $('body').height(initHeight);
  });

  $('body').on('pageAnimationEnd', function(e, data){
    //$(this).height($('div.current').height());
    $('body').height($('#jqt .current').height());
  });

});
